"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const yaml = __importStar(require("js-yaml"));
const fs = __importStar(require("fs"));
const chalk_1 = __importDefault(require("chalk"));
const LOG_PREFIX = "yarn-compose";
function getConfig(configPath) {
    return yaml.safeLoad(fs.readFileSync(configPath, "utf8"));
}
exports.getConfig = getConfig;
function getLogger() {
    return {
        meta: (msg) => console.log(`${chalk_1.default.white(LOG_PREFIX)} ${msg}\n`),
        info: (msg) => console.log(`${chalk_1.default.green("success")} ${msg}`),
        warn: (msg) => console.log(`${chalk_1.default.yellow("warn")} ${msg}`),
        error: (msg) => console.log(`${chalk_1.default.red("error")} ${msg}`)
    };
}
exports.getLogger = getLogger;
